% The cuppafea object browser.
% Launches OB from a GUI.
% (C) 2004-2005, Petr Krysl
%
function OBgui(argin)

    % determine width values
    ftSize=12;
    maxLen=48;
    lButt=maxLen*ftSize*0.7;
    scSize=get(0,'ScreenSize');
    distButt=30;
    winWdth=lButt;

    % number of buttons
    if nargin == 1
        onfields=0;
        for i=1
            s{i} =inputname(i);
            sobj{i} =argin;
            if isa(sobj{i},'classbase')
                onfields=onfields+1;
            end
        end
        nfields=length(s);
    else
        s =evalin('caller','who(''*'')');
        nfields=length(s);
        onfields=0;
        for i=1:nfields
            obj=evalin('caller',s{i});
            if isa(obj,'classbase')
                onfields=onfields+1;
            end
            sobj{i} = obj;
        end
    end

    f1=figure('Position', [scSize(3)/3 scSize(4)/5 winWdth (distButt*1.2 +distButt*(onfields))],...
        'Resize','off', 'DeleteFcn',@deleteme);
    set(f1,...
        'MenuBar','none','NumberTitle','off','Name','OBgui (C) 2004-2005, Petr Krysl',...
        'Units', 'points');
    uicontrol('Style','text','String','Objects',...
        'Position',[0 distButt*(onfields)+2 lButt distButt],...
        'FontSize',ftSize,...
        'FontWeight','bold','BackgroundColor',[0.9 0.9 0.96],...
        'Enable','inactive');
    % place buttons
    j=1;
    for i=1:nfields
        obj=sobj{i};
        if isa(obj,'classbase')
            if length(obj)> 1
                e=uicontrol('Style','edit','String','1',...
                    'Position',[4/5*lButt distButt*(onfields-j)+2 lButt/5 distButt],...
                    'BackgroundColor',[0.95 0.9 0.9],...
                    'FontSize',ftSize);
                uicontrol('Style','pushbutton','String',[s{i} ' (1:' num2str(length(obj)) ')'],'HorizontalAlignment','left',...
                    'Position',[0 distButt*(onfields-j)+2 4/5*lButt distButt],...
                    'TooltipString', class(obj),...
                    'FontSize',ftSize,...
                    'Callback',@buttcall,'UserData',struct('obj',obj,'name',s{i},'fig',f1,'edit',e));
            else
                uicontrol('Style','pushbutton','String',s{i},'HorizontalAlignment','left',...
                    'Position',[0 distButt*(onfields-j)+2 lButt distButt],...
                    'TooltipString', class(obj),...
                    'FontSize',ftSize,...
                    'Callback',@buttcall,'UserData',struct('obj',obj,'name',s{i},'fig',f1));
            end
            j=j+1;
        end
    end
    % wait for user reaction before returning
    %waitfor(f1);
end

function buttcall(hObject,varargin)
    d=get(hObject,'UserData');
    name=d.name;
    if length(d.obj)> 1
        e=d.edit;
        s=get(e,'String');
        try
            j= ceil (sscanf(s, '%d'));
            if isempty(j)
                j=1;
                set(e,'String',num2str(j));
            else
                if (j <1)
                    j=1;
                    set(e,'String',num2str(j));
                elseif j >length(d.obj)
                    j=length(d.obj);
                    set(e,'String',num2str(j));
                end
            end
        catch
            j=1;
            set(e,'String',num2str(j));
        end
        try
            eval ([name ' =d.obj;']);
            eval (['OB(' name '(' num2str(j) '))']);
        catch
        end
    else
        try
            eval ([name ' =d.obj;']);
            eval (['OB(' name ')']);
        catch
        end
    end
    return;
end

function deleteme(hObject,varargin)
    for i=get(hObject,'UserData')
        try
            close(i{1});
        catch
        end
    end
    return;
end